<template>
  <!-- 授权用户 -->
  <el-dialog
    title="选择用户"
    :visible.sync="visible"
    width="800px"
    top="5vh"
    append-to-body
  >
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true">
      <el-form-item label="用户名称" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入用户名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号码" prop="phonenumber">
        <el-input
          v-model="queryParams.phonenumber"
          placeholder="请输入手机号码"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
        >搜索
        </el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
        >重置
        </el-button
        >
      </el-form-item>
    </el-form>
    <el-row>
      <el-table
        @row-click="clickRow"
        ref="table"
        :data="userList"
        @selection-change="handleSelectionChange"
        height="320px"
      >
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column label="头像" width="60" align="center" prop="avatar">
          <template slot-scope="scope">
            <ListImage :image-url="scope.row.avatar"></ListImage>
          </template>
        </el-table-column>
        <el-table-column
          label="用户姓名"
          align="center"
          prop="userName"
          :show-overflow-tooltip="true"
        />
        <el-table-column
          label="部门"
          align="center"
          prop="dept.deptName"
          :show-overflow-tooltip="true"
        />
        <el-table-column
          label="手机"
          align="center"
          width="120px"
          prop="phonenumber"
          :show-overflow-tooltip="true"
        />
        <el-table-column
          label="邮箱"
          align="center"
          width="140px"
          prop="email"
          :show-overflow-tooltip="true"
        />
      </el-table>
      <pagination
        v-show="total > 0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-row>
    <div slot="footer" class="dialog-footer">
      <el-button type="primary" @click="handleSelectUser">确 定</el-button>
      <el-button @click="visible = false">取 消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import {updatePersonnel, listSelect} from "@/api/smartSchool/conferenceManage/selectParticipants";

export default {
  props: {
    // 角色编号
    id: {
      type: [Number, String],
    },
  },
  created() {
    this.areaId = this.$route.query && this.$route.query.id;
    console.log("this.id",this.areaId)
    this.getList();
  },
  data() {
    return {
      areaId:undefined,
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 遮罩层
      visible: false,
      // 选中数组值
      userIds: [],
      // 总条数
      total: 0,
      // 未授权用户数据
      userList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        id: undefined,
        userName: null,
        phonenumber: undefined,
      },
      selectedList: [],
    };
  },
  methods: {
    // 显示弹框
    show() {
      this.id = this.id;
      this.getList();
      this.visible = true;
    },
    clickRow(row) {
      this.$refs.table.toggleRowSelection(row);
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.selectedList = selection;
      this.userIds = selection.map((item) => item.userId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    getList() {
      this.loading = true;
      // listSelect(this.addDateRange(this.queryParams, this.dateRange)).then((response) => {

      listSelect(this.queryParams, this.areaId).then((response) => {
          this.userList = response.rows;
          this.total = response.total;
          this.loading = false;
        }
      );
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 选择授权用户操作 */
    handleSelectUser() {
      this.visible = false;
      this.handleSubmit()
    },
    handleSubmit() {
      updatePersonnel(this.areaId, this.userIds).then((res) => {
        if (res.code == 200) {
          this.$emit("refreshList")
        }

      })
    }
  },
};
</script>
